﻿// Copyright (c) 2007 Google Inc.
// All rights reserved
// 
// This file is part of the Google Desktop SDK and may be freely copied and used.
// To download the latest version of the SDK please visit 
// http://desktop.google.com/developer.html

var FACEBOOK_API_KEY = "bfd0d696825e351ee46d64bfc2195174";
var FACEBOOK_SECRET = "e4c212d00cd51f516f378b4d42030a58";

var ERROR_MSG_TIMEOUT = 3000;
var AUTO_SWITCH_TIME = 15000;
var DL_PHOTO_POLL_INTERVAL = 10100;
var PHOTO_SWITCH_INTERVAL = 10500;
var USER_INFO_FETCH_TIMEOUT = 30000;
var PHOTO_ADD_INTERVAL = 60000;
var CHECK_ONLINE_STATUS_INTERVAL_MS = 10000;  // 10 seconds
var MIN_STARTUP_PHOTOS = 30;

var PAUSED_IMG = "img/pause_default.png";
var PAUSED_DOWN_IMG = "img/pause_down.png";
var PAUSED_OVER_IMG = "img/pause_hover.png";
var PLAY_IMG = "img/play_default.png";
var PLAY_DOWN_IMG = "img/play_down.png";
var PLAY_OVER_IMG = "img/play_hover.png";

var loginIE_ = null;
var facebook_ = null;
var checkForLoginTimer_ = null;
var autoSwitchTimer_ = null;
var loggingIn_ = false;
var paused_ = false;
var photoSlideshow_ = new PhotoSlideshow(DL_PHOTO_POLL_INTERVAL);

function createXhr() {
  return new XMLHttpRequest();
}

function onOpen() {
  // Used to handle the session
  pluginHelper.onAddCustomMenuItems = onAddCustomMenuItems;

  facebook_ = new Facebook(FACEBOOK_API_KEY, FACEBOOK_SECRET, onLogOut);

  // Check if a session exists
  if (doesSessionExist()) {
    debug.trace("It appears a session already exists! Using it!");
    facebook_.setSession(options.getValue("session"), options.getValue("uid"),
      options.getValue("secret"));

    showContactingFacebook();
    startSlideshow();
  }
}

function doesSessionExist() {
  if (options.getValue("session") && options.getValue("uid") && 
      options.getValue("secret")) {
    return true;
  }

  return false;
}

function onAddCustomMenuItems(menu) {
  if (doesSessionExist()) {
    menu.AddItem(LOG_OUT, 0, onLogOut);
    menu.AddItem(RESTART_SLIDESHOW, 0, function() {showContactingFacebook();
      startSlideshow();});
  }
}

function onLogOut() {
  options.remove("session");
  options.remove("uid");
  options.remove("secret");

  facebook_.logout();
  facebook_ = new Facebook(FACEBOOK_API_KEY, FACEBOOK_SECRET, onLogOut);
  
  photoSlideshow_.stopSlideshow();
  photoSlideshow_ = new PhotoSlideshow(DL_PHOTO_POLL_INTERVAL);
  photoSlideshow_.setDisplayArea(picbox);
  photoSlideshow_.startSlideshow(PHOTO_SWITCH_INTERVAL, onDisplayPhoto);

  loginLink.visible = true;
  loginPic.visible = true;
  loginStatus.visible = false;
  continuePanel.visible = false;
  hoverbar.visible = false;
  picbox.src = null;

  stopAllFacebookTimers();
}

function onDisplayPhoto(imageUrl, extraData) {
  loginStatus.visible = false;
  continuePanel.visible = false;
  loginPic.visible = false;
  if (photoOwners_[extraData.owner])
    imageOwner.innerText = photoOwners_[extraData.owner];
  else
    imageOwner.innerText = strings.FETCHING_USER_INFO;
}

function showContactingFacebook() {
  loginPic.visible = true;
  picbox.src = null;
  
  loginLink.visible = false;
  loginStatus.innerText = CONTACTING_FACEBOOK;
  loginStatus.visible = true;
}

function onMouseOver() {
  if (photoSlideshow_.isShowingPhoto())
    hoverbar.visible = true;

  if (!paused_) 
    photoSlideshow_.stopSlideshow();
}

function onMouseOut() {
  hoverbar.visible = false;

  if (!paused_) 
    photoSlideshow_.startSlideshow(PHOTO_SWITCH_INTERVAL, onDisplayPhoto);
}

function onTextClick() {
  showContactingFacebook();

  facebook_.getAuthenticationURL(onReceivedAuthenticationURL);
}

function isLinux() {
  return framework.runtime.osName == 'Linux';
}

function onReceivedAuthenticationURL(URL) {
  if (URL == null) {
    showError(FACEBOOK_ERROR);
    return;
  }

  if (isLinux()) {
    loginLinux(URL);
  } else {
    loginWindows(URL);
  }
}

function loginLinux(URL) {
  framework.openUrl(URL);
  loginStatus.visible = false;
  loginLink.visible = false;
  continuePanel.visible = true;
}

function onContinueClick() {
  facebook_.authenticate(onAuthenticated);
}

function loginWindows(URL) {
  // Prepare the details view
  loginIE_ = new WebBrowser();
  loginIE_.navigate2(URL);

  // Show the details view
  pluginHelper.showDetailsView(loginIE_, PLEASE_LOGIN,
    gddDetailsViewFlagToolbarOpen, onLoginWindowClose);

  loginStatus.innerText = PLEASE_LOGIN;

  // Begin the timer to check for when the user has logged in
  checkForLoginTimer_ = setInterval(checkForLogin, 500);
}

function onLoginWindowClose(detailsViewFlags) {
  if (!loggingIn_) {
    loginStatus.visible = false;
    loginLink.visible = true;
  }
}

function checkForLogin() {
  // Do a quick check to see if the IE control exists
  if (loginIE_ == null) {
    if (checkForLoginTimer_ != null)
      clearInterval(checkForLoginTimer_);
    debug.error("No IE control - cannot check");
    return;
  }

  var text = "";
  try {
    // Attempt to access the IE control, if it's closed, it will cause an error
    var dummy = loginIE_.visible;
  } catch (e) {
    if (checkForLoginTimer_ != null)
      clearInterval(checkForLoginTimer_);
    debug.error("Failed to access loginIE_ object");
    return;
  }

  if (!loginIE_.Document) {
    return;
  }

  // Check if the user is logged in
  var href = loginIE_.Document.location.href;
  if (href.indexOf("/desktopapp.php") == -1)
    return;

  // Since logged in, close details view
  loggingIn_ = true;
  pluginHelper.CloseDetailsView();
  loggingIn_ = false;
  if (checkForLoginTimer_ != null) 
    clearInterval(checkForLoginTimer_);
  loginIE_ = null;

  // Get authentication
  loginStatus.innerText = LOGGING_IN;
  facebook_.authenticate(onAuthenticated);
}

function showError(text) {
  // If in debug made, show the error in the debug console
  debug.trace(text);

  picbox.src = "";
  loginLink.visible = false;
  continuePanel.visible = false;
  loginStatus.innerText = text;
  loginStatus.visible = true;
  loginPic.visible = true;
  
  // Destroy any possible objects used midway
  if (checkForLoginTimer_ != null) {
    clearInterval(checkForLoginTimer_);
    checkForLoginTimer_ = null;
  }

  loginIE_ = null;
  if (facebook_ != null) {
    facebook_.stop();
    facebook_ = new Facebook(FACEBOOK_API_KEY, FACEBOOK_SECRET, onLogOut);
  }

  setTimeout(onErrorDone, ERROR_MSG_TIMEOUT);
}

function onErrorDone() {
  continuePanel.visible = false;
  loginStatus.visible = false;
  loginLink.visible = true;
}

function onAuthenticated(status) {
  if (status == false) {
    showError(FACEBOOK_ERROR_LOGIN);
    return;
  }

  continuePanel.visible = false;
  loginStatus.visible = true;
  loginLink.visible = false;
  loginStatus.innerText = LOADING_PHOTOS;
  startSlideshow();
}


///////////

function onPrevClick() {
  photoSlideshow_.showNextPhoto(-1);
}

function onNextClick() {
  photoSlideshow_.showNextPhoto(1);
}

function onPauseClick() {
  paused_ = !paused_;

  if (!paused_) {
    playpause.image = PAUSED_IMG;
    playpause.downImage = PAUSED_DOWN_IMG;
    playpause.overImage = PAUSED_OVER_IMG;
  } else {
    playpause.image = PLAY_IMG;
    playpause.downImage = PLAY_DOWN_IMG;
    playpause.overImage = PLAY_OVER_IMG;
  }
}

function onImageDblClick() {
  var extraData = photoSlideshow_.getCurrentPhotoExtraData();

  if (extraData) {
    framework.openUrl(extraData.link.replace("&amp;", "&"));
  }
}

////////////////////////////////////////////////////////
////////////////////////////////////////////////////////

// Slow and fast timers are required for friends polling. A slow timer is
// the regular one which gets new friends at periodic times. A fast timer is
// used when the user has stale photos and a network problem is preventing new
// photos from coming in.
var GET_FRIENDS_RETRY_MS = 5*1000;
var GET_FRIENDS_RETRY_MAX_MS = 2*60*1000;
var GET_ALBUMS_POLL_INTERVAL = 14100;
var GET_PHOTOS_POLL_INTERVAL = 15100;
var STOP_DESPERATE_TIMEOUT = 60000;

var GET_FRIENDS_NO_FRIENDS_RETRY_MS = 10*1000;
var GET_FRIENDS_NO_FRIENDS_RETRY_MAX = 3;

var queuedFriends_ ;
var queuedAlbums_ ;
var queuedPhotos_ ;
var photoOwners_;

var desperate_ = false;
var friendsRetryTimeoutlMs = GET_FRIENDS_RETRY_MS;
var noFriendsRetryCount = 0;

var getNextAlbumBatch_ = null;
var getNextPhotoBatch_ = null;
var addMorePhotos_ = null;
var stopDesperate_ = null;

function resetDataAndSlideshow() {
  // fix up initial timers and counters
  friendsRetryTimeoutlMs = GET_FRIENDS_RETRY_MS;
  noFriendsRetryCount = 0;
  
  // clear all facebook data
  queuedFriends_ = [];  // User IDs waiting to be scanned for albums
  queuedAlbums_ = [];   // Albums waiting to be scanned for photos
  queuedPhotos_ = [];   // photos waiting to be added to the slideshoe
  photoOwners_ = {};
  
  // stop everything from the previous slideshow
  photoSlideshow_.stopSlideshow();
  photoSlideshow_.stopPhotoDownload();
  
  // restart the slideshow
  photoSlideshow_ = new PhotoSlideshow(DL_PHOTO_POLL_INTERVAL);
  photoSlideshow_.setDisplayArea(picbox);
  photoSlideshow_.startSlideshow(PHOTO_SWITCH_INTERVAL, onDisplayPhoto);
}

function stopAllFacebookTimers() {
  // Stop all existing timers
  view.clearInterval(getNextAlbumBatch_);
  view.clearInterval(getNextPhotoBatch_);
  view.clearInterval(addMorePhotos_);
  
  getNextAlbumBatch_ = null;
  getNextPhotoBatch_ = null;
}

function startAllFacebookTimers() {
  debug.trace("starting facebook timers at regular intervals");
  getNextAlbumBatch_ = setInterval(getNextAlbumBatch, GET_ALBUMS_POLL_INTERVAL);
  getNextPhotoBatch_ = setInterval(getNextPhotoBatch, GET_PHOTOS_POLL_INTERVAL);
  addMorePhotos_ = setInterval(addPhotoToSlideshow, PHOTO_ADD_INTERVAL);
}

function addPhotoToSlideshow() {
  if (queuedPhotos_.length > 0) {
    debug.trace("adding photo to slideshow");
    var photo = queuedPhotos_.pop();
    var imageUrl = photo[0];
    var extraData = photo[1];
    photoSlideshow_.addPhoto(imageUrl, extraData);
    if (desperate_) {
      if (photoSlideshow_.isShowingPhoto()) {
        // Retrieve it quicker so we have a healthy set of images.
        photoSlideshow_.downloadPhoto(imageUrl);
      } else {
        // Nothing being shown. Show the new pic immediately.
        photoSlideshow_.showPhoto(imageUrl);
      }
    }
  }
}

// Start the desperate mode. The desperate mode pretty much forces facebook to
// give us as much info as possible to get a picture out there quick.
function startSlideshow() {
  desperate_ = true;
  resetDataAndSlideshow();
  stopAllFacebookTimers();
  
  getFriends();
}

function stopDesperate() {
  debug.trace("Stopping desperate getting...");
  desperate_ = false;

  if (stopDesperate_)
    clearInterval(stopDesperate_);
  stopDesperate_ = null;

  stopAllFacebookTimers();
  startAllFacebookTimers();
}

// Called to get start retrieving the friends list
function getFriends() {
  if (framework.system.network.online == false) {
    debug.error("NOT ONLINE! Will check again in " + CHECK_ONLINE_STATUS_INTERVAL_MS + "ms.");
    setTimeout(getFriends, CHECK_ONLINE_STATUS_INTERVAL_MS);
    return;
  }
  facebook_.getFriends(gotFriendsBatch);
  stopDesperate_ = setTimeout(stopDesperate, STOP_DESPERATE_TIMEOUT);
}

// Received the list of friends from Facebook. This is also an indication that
// our session keys work/don't work
function gotFriendsBatch(friends) {
  if (friends == null) {
    // Failed to get friends. do exponential backoff
    if (friendsRetryTimeoutlMs > GET_FRIENDS_RETRY_MAX_MS) {
      friendsRetryTimeoutlMs = GET_FRIENDS_RETRY_MAX_MS;
    }
    setTimeout(getFriends, friendsRetryTimeoutlMs);
    debug.trace("Couldn't get friends. Retrying in " + friendsRetryTimeoutlMs + "ms");
    friendsRetryTimeoutlMs = 2*friendsRetryTimeoutlMs;
    return;
  }

  // success, so reset retry timeout for next time
  friendsRetryTimeoutlMs = GET_FRIENDS_RETRY_MS;
  
  // Since the API is confirmed to work, save the session keys.
  var session = facebook_.getSession();
  options.putValue("session", session.sessionKey);
  options.putValue("uid", session.uid);
  options.putValue("secret", session.secret);
  debug.trace("SET SESSION. Got " + friends.length + " friends.");

  // Got all friends
  shuffle(friends);
  queuedFriends_ = friends;
  if (queuedFriends_.length == 0) {
    
    // sometimes facebook returns that you have 0 friends BUT in fact you do
    // have friends.. so we do some refetching to be sure you have no friends
    // before saying you have no friends
    if (noFriendsRetryCount < GET_FRIENDS_NO_FRIENDS_RETRY_MAX) {
      noFriendsRetryCount += 1;
      setTimeout(getFriends, GET_FRIENDS_NO_FRIENDS_RETRY_MS);
    } else {
      loginStatus.innerText = NO_FRIENDS;
    }
    return;
  }
  // If in desperate mode, quickly go get the albums
  if (desperate_)
    getNextAlbumBatch();
}

function gotFriendsInfo(friendsInfo, friends) {
  if (friendsInfo) {
    for (var i = 0; i < friendsInfo.length; ++i) {
      var uid = friendsInfo[i][0];
      var name = friendsInfo[i][1];
      debug.trace("got uid " + uid + " " + name);
      photoOwners_[uid] = name;
      
      // now update the currently displayed photo in case it doesn't have
      // the data
      var extraData = photoSlideshow_.getCurrentPhotoExtraData();
      if (extraData && extraData.owner == uid)
        imageOwner.innerText = name;
    }
  } else {
    debug.error("Friend Info Fetch failed! Retrying in " 
      + USER_INFO_FETCH_TIMEOUT + 'ms.');
    view.setTimeout(function () {
      facebook_.getFriendsInfo(friends, gotFriendsInfo);
      }, USER_INFO_FETCH_TIMEOUT);
  }
}

// Called to get the full list of albums from the next friend
function getNextAlbumBatch() {
  // Check if there are any friends even in queue
  if (queuedFriends_.length == 0)
    return;

  // Get an friend and remove it from the queue
  var friend = queuedFriends_.pop();
  
  // Contact facebook to get all images in the album
  facebook_.getAlbums(friend, gotAlbumsBatch);
}

// Received the list of friends from Facebook
function gotAlbumsBatch(albums, uid) {
  if (albums == null) {
    // Failed to get the albums for the friend. The user is likely offline,
    // therefore add the friend back on the list!
    debug.trace("albums failure, re-adding friend.");
    queuedFriends_.push(uid);
  } else {
  
    if (queuedFriends_.length == 0 && albums.length == 0 
      && queuedAlbums_.length == 0 && photoSlideshow_.photos.length == 0)
      loginStatus.innerText = NO_PHOTOS;
    
    // this friend had no albums, but we don't want to keep using
    // other albums, so re-fetch
    if (desperate_ && albums.length == 0) {
      debug.trace("no albums for this friend. fetching another");
      setTimeout(getNextAlbumBatch, 1000);
      return;
    }
    
    // Got albums
    queuedAlbums_ = queuedAlbums_.concat(albums);
    shuffle(queuedAlbums_);
  }
  if (desperate_) {
    if (queuedAlbums_.length == 0)
      getNextAlbumBatch();
    else
      getNextPhotoBatch();
  }
}

// Called to get the full list of photos from the next album
function getNextPhotoBatch() {
  // Check if there are any friends even in queue
  if (queuedAlbums_.length == 0) {
    if (desperate_)
      getNextAlbumBatch();

    return;
  }

  // Get an album and remove it from the queue
  var album = queuedAlbums_.pop();
  
  // Contact facebook to get all images in the album
  facebook_.getPhotos(album, gotPhotoBatch);
}

// Received the list of friends from Facebook
function gotPhotoBatch(photos, aid) {
  if (photos == null) {
    // Failed to get the photos for the friend. The user is likely offline,
    // therefore add the friend back on the list!
    debug.trace("photos failure, re-adding album.");
    queuedAlbums_.push(aid);
  } else {
    shuffle(photos);
    // Got all photos -- now add some to our photos list
    debug.trace("got " + photos.length + " photos.");
    for (var i = 0; i < photos.length; ++i) { 
      var image = photos[i];
      var imageUrl = image.src;

      var extraData = new Object();
      extraData.link = image.link;
      extraData.owner = image.owner;

     // fetch photo owner info if we don't already have it
      if (!photoOwners_[image.owner]) {
        debug.trace("fetching uid " + image.owner);
        facebook_.getFriendsInfo([image.owner], gotFriendsInfo);
      }

      queuedPhotos_.push([imageUrl, extraData]);
    }
    
    addPhotoToSlideshow();
    shuffle(queuedPhotos_);    
  }
  
  // we've got photos and we're displaying them, so stop the desperation
  if (desperate_ && photoSlideshow_.getPhotoCount() >= MIN_STARTUP_PHOTOS) {
    stopDesperate();
  } else {
    getNextAlbumBatch();
  }

}

function onResize() {
/*
<view width="246" height="200">

  <!-- Top border -->
  <img name="__tbl" src="img/top_left.png" x="0" y="0" />
  <div name="__tbm" width="226" height="10" x="10" y="0" background="img/top.png" />
  <img name="__tbr" src="img/top_right.png" x="236" y="0" />
*/
  __tbm.width = view.width - 18;
  __tbr.x = view.width - 8;


/*  
  <!-- Left and right borders -->
  <div name="__ml" width="10" height="169" x="0" y="10" background="img/left.png" />
  <div name="__mr" width="10" height="169" x="236" y="10" background="img/right.png" />
*/
  __ml.height = view.height - 16;
  __mr.height = __ml.height;
  __mr.x = view.width - 8;
    
/*  
  <!-- Bottom border -->
  <img name="__bbl" src="img/bottom_left.png" x="0" y="179" />
  <div name="__bbm" width="226" height="10" x="10" y="179" background="img/bottom.png" />
  <img name="__bbr" src="img/bottom_right.png" x="236" y="179" />
*/
  __bbl.y = view.height - 8;
  __bbm.y = __bbl.y;
  __bbm.width = view.width - 20;
  __bbr.y = __bbl.y;
  __bbr.x = view.width - 10;

/*
  <!-- Center -->
  <div name="centerDiv" x="4" y="4" width="234" height="177" background="#FFFFFF">
*/
  centerDiv.width = view.width - 8;
  centerDiv.height = view.height - 8;  
  
/*  
    <div name="hoverbox" x="0" y="0" width="100%" height="100%" background="#AAAAAA">
      <img name="picbox" x="0" y="0" width="100%" height="100%" enabled="true"
        cropMaintainAspect="photo" ondblclick="onImageDblClick();"/>
*/

/* different kind of resizing, a bit fancy and it makes the gadget look a bit
 * funny when borders go grey and you start to cycle through
  var ideal_height = picbox.srcHeight;
  var ideal_width = picbox.srcWidth;
  
  picbox.height = centerDiv.height < ideal_height ? centerDiv.height : ideal_height;
  picbox.width = centerDiv.width < ideal_width ? centerDiv.width : ideal_width;
  */
  
  picbox.height = centerDiv.height; 
  picbox.width = centerDiv.width;
  
  picbox.x = (centerDiv.width - picbox.width) / 2;
  picbox.y = (centerDiv.height - picbox.height) / 2;
 
/*        
      <img name="loginPic" x="4" y="82" width="226" height="87" src="img/crowd.png"/>    
*/
  loginPic.x = (view.width - loginPic.width) / 2;
  loginPic.y = (view.height - loginPic.height) / 2;
  if (loginPic.x < 0) {
    loginPic.x = 4;
    loginPic.width = view.width - 8;
  }
  if (loginPic.y < 0) {
    loginPic.y = 4;
    loginPic.height = view.height - 8;
  }
  
/*
      <a name="loginLink" x="1" y="0" width="229" height="177" align="center"
                vAlign="middle" size="16" onclick="onTextClick();" color="#FFFFFF"
                overColor="#FFFFFF" font="Arial" wordWrap="true">
        &CLICK_TO_LOGIN;
      </a>
*/
  loginLink.width = view.width - 17;
  loginLink.height = view.height - 8;
/*       
      <label name="loginStatus" x="1" y="74" width="229" height="50" color="#FFFFFF"
        align="center" vAlign="middle" size="16" wordWrap="true" font="Arial" />
*/
  loginStatus.y = (view.height - 50 - 23) / 2;
  if (loginStatus.y < 0)
    loginStatus.y = 0;
  loginStatus.width = view.width - 17;  

/*
        <div name="hoverbar" x="0" y="153" width="100%" height="100%" 
          background="img/hover_base.png" visible="false">
*/
  hoverbar.y = view.height - 32;
  imageOwner.width = view.width - 83;

/*          
        <button x="0" y="1" image="img/previous_default.png" 
          downImage="img/previous_down.png" overImage="img/previous_hover.png" 
          onclick="onPrevClick();" />
*/
/*        <button name="playpause" x="23" y="1" image="img/pause_default.png" 
          downImage="img/pause_down.png" overImage="img/pause_hover.png" 
          onclick="onPauseClick();" />
        <!--<button x="23" y="1" image="img/play_default.png" 
          downImage="img/play_down.png" overImage="img/play_hover.png" />-->
*/
/*        <button x="46" y="1" image="img/next_default.png" 
          downImage="img/next_down.png" overImage="img/next_hover.png" 
          onclick="onNextClick();" />

        <label name="imageOwner" x="69" y="4" width="165" color="#ffffff" 
          align="right" />
*/

/*      </div>
    </div>
  </div>
*/
}

function onSizing() {
  if (event.width < 85) event.width = 85;
  if (event.height < 100) event.height = 100;
}

///// utilities ////
/**
 * Randomly shuffles an array using the Fisher-Yates algorithm
 * @param {Array} The array to shuffle
 */
function shuffle(theArray) {
  var i = theArray.length;
  if (i == 0) {
    return;
  }
  while (--i) {
    var j = Math.floor(Math.random() * ( i + 1 ));
    var temp1 = theArray[i];
    theArray[i] = theArray[j];
    theArray[j] = temp1;
  }
}
